MinCostArborescence< GR, CM, TR >::SetArborescenceMap< T > Struct Template Reference

- Main Page
- Modules
- Classes
- Namespaces
- Files
- Related Pages

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
List of all members
MinCostArborescence< GR, CM, TR >::SetArborescenceMap< T > Struct Template Reference

## Detailed Description

### template<typename GR, typename CM, typename TR>
template<class T>
struct lemon::MinCostArborescence< GR, CM, TR >::SetArborescenceMap< T >

Named parameter for setting `ArborescenceMap` type. It must conform to the WriteMap concept, and its value type must be `bool` (or convertible). Initially it will be set to `false` on each arc, then it will be set on each arborescence arc once.

`#include <lemon/min_cost_arborescence.h>`

Inheritance diagram for MinCostArborescence< GR, CM, TR >::SetArborescenceMap< T >:
[legend]

## Additional Inherited Members
Public Types inherited from MinCostArborescence< Digraph, CostMap, SetArborescenceMapTraits< T > >
typedef SetArborescenceMapTraits< T > | Traits
| The traits class of the algorithm.
typedef Traits::Digraph | Digraph
| The type of the underlying digraph.
typedef Traits::CostMap | CostMap
| The type of the map that stores the arc costs.
typedef Traits::Value | Value
| The type of the costs of the arcs.
typedef Traits::PredMap | PredMap
| The type of the predecessor map.
typedef Traits::ArborescenceMap | ArborescenceMap
| The type of the map that stores which arcs are in the arborescence.
Public Member Functions inherited from MinCostArborescence< Digraph, CostMap, SetArborescenceMapTraits< T > >
| MinCostArborescence (const Digraph &digraph, const CostMap &cost)
| Constructor. More...
| ~MinCostArborescence ()
| Destructor.
MinCostArborescence & | arborescenceMap (ArborescenceMap &m)
| Sets the arborescence map. More...
MinCostArborescence & | predMap (PredMap &m)
| Sets the predecessor map. More...
const ArborescenceMap & | arborescenceMap () const
| Returns a const reference to the arborescence map. More...
const PredMap & | predMap () const
| Returns a const reference to the pred map. More...
Value | arborescenceCost () const
| Returns the cost of the arborescence. More...
bool | arborescence (Arc arc) const
| Returns `true` if the arc is in the arborescence. More...
Arc | pred (Node node) const
| Returns the predecessor arc of the given node. More...
bool | reached (Node node) const
| Indicates that a node is reachable from the sources. More...
bool | processed (Node node) const
| Indicates that a node is processed. More...
int | dualNum () const
| Returns the number of the dual variables in basis. More...
Value | dualValue () const
| Returns the value of the dual solution. More...
Value | dualValue (int k) const
| Returns the value of the dual variable. More...
int | dualSize (int k) const
| Returns the number of the nodes in the dual variable. More...
void | init ()
| Initializes the internal data structures. More...
void | addSource (Node source)
| Adds a new source node. More...
Node | processNextNode ()
| Processes the next node in the priority queue. More...
int | queueSize () const
| Returns the number of the nodes to be processed. More...
bool | emptyQueue () const
| Returns `false` if there are nodes to be processed. More...
void | start ()
| Executes the algorithm. More...
void | run (Node s)
| Runs MinCostArborescence algorithm from node `s`. More...